From d102cc4c4c8f167bab1fed3356f3f3764009de27 Mon Sep 17 00:00:00 2001
From: Pierre-Yves Chibon <pingou@pingoured.fr>
Date: Apr 26 2016 09:25:42 +0000
Subject: [PATCH 445/1001] Allow cleaning the cache of multiple widgets at once


---

diff --git a/smart_cache_invalidator.py b/smart_cache_invalidator.py
index ee8f298..7e53851 100755
--- a/smart_cache_invalidator.py
+++ b/smart_cache_invalidator.py
@@ -46,12 +46,15 @@ def do_clean(args):
             os.unlink(filename)
 
     db = anydbm.open(args.cache_db, 'w')
-    for key in db.keys():
-        widget_id = key.split('|')[0]
-        widget = hubs.models.Widget.get(session, widget_id)
-        if args.widget in [widget.plugin if widget else '', widget_id]:
-            del(db[key])
-            break
+    for widget in args.widgets:
+        for key in db.keys():
+            widget_id = key.split('|')[0]
+            wid_obj = hubs.models.Widget.get(session, widget_id)
+            if widget in [wid_obj.plugin if wid_obj else '', widget_id]:
+                print('- Removing cached {0} (#{1}) in {2}'.format(
+                      widget.hub_id, widget_id, widget.plugin))
+                del(db[key])
+                break
     db.close()
 
 
@@ -77,7 +80,8 @@ def setup_parser():
     parser_clean = subparsers.add_parser(
         'clean', help='Clean the specified widget')
     parser_clean.add_argument(
-        'widget', help="Identifier or name of the widget to clean")
+        'widgets', nargs="+",
+        help="Identifier or name of the one or moe widgets to clean")
     parser_clean.set_defaults(func=do_clean)
 
     return parser

